# frozen_string_literal: true

# WARNING ABOUT GENERATED CODE
#
# This file is generated. See the contributing guide for more information:
# https://github.com/aws/aws-sdk-ruby/blob/version-3/CONTRIBUTING.md
#
# WARNING ABOUT GENERATED CODE


module Aws::STS
  # @api private
  module Endpoints

    class AssumeRole
      def self.build(context)
        Aws::STS::EndpointParameters.new(
          region: context.config.region,
          use_dual_stack: context.config.use_dualstack_endpoint,
          use_fips: context.config.use_fips_endpoint,
          endpoint: context.config.regional_endpoint ? nil : context.config.endpoint.to_s,
          use_global_endpoint: context.config.sts_regional_endpoints == 'legacy',
        )
      end
    end

    class AssumeRoleWithSAML
      def self.build(context)
        Aws::STS::EndpointParameters.new(
          region: context.config.region,
          use_dual_stack: context.config.use_dualstack_endpoint,
          use_fips: context.config.use_fips_endpoint,
          endpoint: context.config.regional_endpoint ? nil : context.config.endpoint.to_s,
          use_global_endpoint: context.config.sts_regional_endpoints == 'legacy',
        )
      end
    end

    class AssumeRoleWithWebIdentity
      def self.build(context)
        Aws::STS::EndpointParameters.new(
          region: context.config.region,
          use_dual_stack: context.config.use_dualstack_endpoint,
          use_fips: context.config.use_fips_endpoint,
          endpoint: context.config.regional_endpoint ? nil : context.config.endpoint.to_s,
          use_global_endpoint: context.config.sts_regional_endpoints == 'legacy',
        )
      end
    end

    class DecodeAuthorizationMessage
      def self.build(context)
        Aws::STS::EndpointParameters.new(
          region: context.config.region,
          use_dual_stack: context.config.use_dualstack_endpoint,
          use_fips: context.config.use_fips_endpoint,
          endpoint: context.config.regional_endpoint ? nil : context.config.endpoint.to_s,
          use_global_endpoint: context.config.sts_regional_endpoints == 'legacy',
        )
      end
    end

    class GetAccessKeyInfo
      def self.build(context)
        Aws::STS::EndpointParameters.new(
          region: context.config.region,
          use_dual_stack: context.config.use_dualstack_endpoint,
          use_fips: context.config.use_fips_endpoint,
          endpoint: context.config.regional_endpoint ? nil : context.config.endpoint.to_s,
          use_global_endpoint: context.config.sts_regional_endpoints == 'legacy',
        )
      end
    end

    class GetCallerIdentity
      def self.build(context)
        Aws::STS::EndpointParameters.new(
          region: context.config.region,
          use_dual_stack: context.config.use_dualstack_endpoint,
          use_fips: context.config.use_fips_endpoint,
          endpoint: context.config.regional_endpoint ? nil : context.config.endpoint.to_s,
          use_global_endpoint: context.config.sts_regional_endpoints == 'legacy',
        )
      end
    end

    class GetFederationToken
      def self.build(context)
        Aws::STS::EndpointParameters.new(
          region: context.config.region,
          use_dual_stack: context.config.use_dualstack_endpoint,
          use_fips: context.config.use_fips_endpoint,
          endpoint: context.config.regional_endpoint ? nil : context.config.endpoint.to_s,
          use_global_endpoint: context.config.sts_regional_endpoints == 'legacy',
        )
      end
    end

    class GetSessionToken
      def self.build(context)
        Aws::STS::EndpointParameters.new(
          region: context.config.region,
          use_dual_stack: context.config.use_dualstack_endpoint,
          use_fips: context.config.use_fips_endpoint,
          endpoint: context.config.regional_endpoint ? nil : context.config.endpoint.to_s,
          use_global_endpoint: context.config.sts_regional_endpoints == 'legacy',
        )
      end
    end

  end
end
